{ *************************************************************

Autor              : Andre Dahmen

Programmiersprache : Turbo Pascal 4.0 (c) Borland

Dieses Programm dient zum einschalten des Hafengebaeude - Bit
in einer erstellten Welt von (c)DIE SIEDLER II mit
(c)DIE SIEDLER II MISSION CD  von BlueByte.

Zur Installation von DIE SIEDLER II:
1.) DIE SIEDLER II installieren.
2.) Update Patch von BlueByte installieren
3.) DIE SIEDLER II MISSION CD Installieren
4.) Update Patch MISSION CD von BlueByte installieren

Anwendung :
Eine Welt erstellen. Dabei darauf achten dass an der gewuenschten
Stelle, wo ein Hafen hinsoll, Platz fuer ein grosses Gebaeude ist.
Diese Stelle (x,y Koordinaten , werden oben links im Editor angezeigt)
notieren.

Nach dem Speichern der Welt den S2EDITOR verlassen und eine Datei "ANKER.DAT"
in WORLDS Verzeichnis mit den Koordinaten der Haefen erstellen.
z.B.

3
10<TAB>10
34<TAB>30
40<TAB>14


Das bedeutet : 3 Haefen auf den Koordinaten (10,10),(34,30) und (40,14).

Dann das Programm ANKER.PAS ausfuehren.

**************************************************************** }
Program Anker;
uses crt,dos;



Var
	datei1		: file of Byte;
	Datei2		: Text;
	Adr,MaxAdr	: LongInt;

	MaxAnker,i	: Integer;
	x,y			: Array[1..16] of Integer;
	x_gr,y_gr	: LongInt;
	Block			: LongInt;

	ww				: Byte;
	name			: String;
   para			: Word;


{ -------------------------------------------- }


Function hex24bit(wert : LongInt):string;
Var
	d1,d2,d3,d4,d5,d6	: Byte;
	q1,q2,q3,q4,q5,q6	: Char;
Begin
	d1 :=  wert and $00000F;
	d2 := (wert and $0000F0) div $000010;
	d3 := (wert and $000F00) div $000100;
	d4 := (wert and $00F000) div $001000;
	d5 := (wert and $0F0000) div $010000;
	d6 := (wert and $F00000) div $100000;


	If d1 > 9 then q1 := chr(d1 + 55) else q1 := chr(48+d1);
	If d2 > 9 then q2 := chr(d2 + 55) else q2 := chr(48+d2);
	If d3 > 9 then q3 := chr(d3 + 55) else q3 := chr(48+d3);
	If d4 > 9 then q4 := chr(d4 + 55) else q4 := chr(48+d4);
	If d5 > 9 then q5 := chr(d5 + 55) else q5 := chr(48+d5);
	If d6 > 9 then q6 := chr(d6 + 55) else q6 := chr(48+d6);
	Hex24bit := q6 + q5 + q4 + q3 + q2 + q1;
end;

{ -------------------------------------------- }



Begin

	Assign(Datei2,'Anker.dat');	Reset(Datei2);
	readLn(Datei2,maxAnker);
	For i := 1 to MaxAnker do Begin
		ReadLn(Datei2,x[i],y[i]);
		x[i] := x[i] + 1;
	end;
	Close(Datei2);

   Para	:= ParamCount;
	If (Para=1) and (Paramstr(1) = '?') then para := 0;
	If (Para=1) then Begin
		name := ParamStr(1);

		Assign(datei1,name);		Reset(Datei1);
		MaxAdr := FileSize(Datei1);

		Seek(Datei1,$092c);	Read(Datei1,ww);	x_gr := ww;
		Seek(Datei1,$092d);	Read(Datei1,ww);	x_gr := x_gr + ww*256;
		Seek(Datei1,$092e);	Read(Datei1,ww);	y_gr := ww;
		Seek(Datei1,$092F);	Read(Datei1,ww);	y_gr := y_gr + ww * 256;

		WriteLN(Hex24bit(x_gr));
		WriteLN(Hex24bit(y_gr));

		Block := x_gr * y_gr + 16;

		WriteLN(Hex24bit(Block));

		For I := 1 to MaxAnker do Begin

			{ *********** TERRAIN ** Breich  2 *********** }

			Adr := $092f + Block + 16 + x[i] + y[i]*X_Gr;
			WriteLn('  2 :',Hex24bit(adr));

			If adr <= MaxAdr then Begin
				Seek(Datei1,Adr);	Read(Datei1,ww);
				ww := ww or $40;
				Seek(Datei1,Adr);	Write(Datei1,ww);
			end;
			{ ----------- TERRAIN -- Breich  2 ----------- }
		end;
		Close(Datei1);
	end else Begin
		WriteLn('ANKER WELTNAME.EXT');
	end;
end.




